//## begin module%1.4%.codegen_version preserve=yes
//   Read the documentation to learn more about C++ code generator
//   versioning.
//## end module%1.4%.codegen_version

//## begin module%41864D9F0301.cm preserve=no
//	  %X% %Q% %Z% %W%
//## end module%41864D9F0301.cm

//## begin module%41864D9F0301.cp preserve=no
//## end module%41864D9F0301.cp

//## Module: ChainManager%41864D9F0301; Package specification
//## Subsystem: XSFit::MCMC%41E6AA18032C
//## Source file: /local/data/xerxes1/gordon/headas/Xspec/src/XSFit/MCMC/ChainManager.h

#ifndef CHAINMANAGER_H
#define CHAINMANAGER_H 1

//## begin module%41864D9F0301.additionalIncludes preserve=no
//## end module%41864D9F0301.additionalIncludes

//## begin module%41864D9F0301.includes preserve=yes
#include <xsTypes.h>
#include <XSUtil/Utils/XSutility.h>
#include <iosfwd>
//## end module%41864D9F0301.includes

// Chain
#include <XSFit/MCMC/Chain.h>

class MarginGrid;
class RandomizerBase;

//## begin module%41864D9F0301.declarations preserve=no
//## end module%41864D9F0301.declarations

//## begin module%41864D9F0301.additionalDeclarations preserve=yes
//## end module%41864D9F0301.additionalDeclarations


//## begin ChainManager%41864F1C034A.preface preserve=yes
//## end ChainManager%41864F1C034A.preface

//## Class: ChainManager%41864F1C034A
//## Category: XSFit::MCMC%41E6AB1C02FC
//## Subsystem: XSFit::MCMC%41E6AA18032C
//## Persistence: Transient
//## Cardinality/Multiplicity: n



//## Uses: <unnamed>%461BE9EA02B0;Numerics::DefaultRandomGenerator { -> }
//## Uses: <unnamed>%462E3A7103A9;RandomizerBase { -> F}

class ChainManager 
{
  //## begin ChainManager%41864F1C034A.initialDeclarations preserve=yes
  //## end ChainManager%41864F1C034A.initialDeclarations

  public:
    //## Class: ChainContainer%41801AA6039A
    //## Category: XSFit::MCMC%41E6AB1C02FC
    //## Subsystem: XSFit::MCMC%41E6AA18032C
    //## Persistence: Transient
    //## Cardinality/Multiplicity: n



    typedef std::map<string,Chain*> ChainContainer;

    //## Class: Stats%473C57D50187
    //## Category: XSFit::MCMC%41E6AB1C02FC
    //## Subsystem: XSFit::MCMC%41E6AA18032C
    //## Persistence: Transient
    //## Cardinality/Multiplicity: n



    struct Stats 
    {
        //## Constructors (generated)
          Stats();

        // Data Members for Class Attributes

          //## Attribute: means%473C583803D5
          //## begin ChainManager::Stats::means%473C583803D5.attr preserve=no  public: std::vector<Real> {U} 
          std::vector<Real> means;
          //## end ChainManager::Stats::means%473C583803D5.attr

          //## Attribute: totalMean%473C58610092
          //## begin ChainManager::Stats::totalMean%473C58610092.attr preserve=no  public: Real {U} 
          Real totalMean;
          //## end ChainManager::Stats::totalMean%473C58610092.attr

          //## Attribute: totalVar%473C587F002F
          //## begin ChainManager::Stats::totalVar%473C587F002F.attr preserve=no  public: Real {U} 
          Real totalVar;
          //## end ChainManager::Stats::totalVar%473C587F002F.attr

          //## Attribute: varInChains%473C589601B1
          //## begin ChainManager::Stats::varInChains%473C589601B1.attr preserve=no  public: Real {U} 
          Real varInChains;
          //## end ChainManager::Stats::varInChains%473C589601B1.attr

          //## Attribute: rubinGelman%473C58B30166
          //## begin ChainManager::Stats::rubinGelman%473C58B30166.attr preserve=no  public: Real {U} 
          Real rubinGelman;
          //## end ChainManager::Stats::rubinGelman%473C58B30166.attr

          //## Attribute: fracRepeats%473C58C90088
          //## begin ChainManager::Stats::fracRepeats%473C58C90088.attr preserve=no  public: std::vector<Real> {U} 
          std::vector<Real> fracRepeats;
          //## end ChainManager::Stats::fracRepeats%473C58C90088.attr

      public:
      protected:
      private:
      private: //## implementation
    };

    //## Destructor (generated)
      ~ChainManager();


    //## Other Operations (specified)
      //## Operation: Instance%4186522E02D8
      static ChainManager* Instance ();

      //## Operation: addChain%418656F401E5
      void addChain (Chain* chain);

      //## Operation: removeChain%418656FD028E
      bool removeChain (const string& fileName);

      //## Operation: clearChains%4186570700F5
      void clearChains ();

      //## Operation: widthConflict%41866E0F0384
      bool widthConflict (const Chain* newChain) const;

      //## Operation: recalc%4194E28A035A
      void recalc ();

      //## Operation: calcStat%4198DA6303A9
      void calcStat (size_t iPar, const string& modName);

      //## Operation: removeChains%419BDA71000A
      void removeChains (const IntegerArray& chainNums);

      //## Operation: checkLengths%41A224230324
      bool checkLengths ();

      //## Operation: getRandomPoint%461BE47703D6
      void getRandomPoint (RealArray& parVals) const;

      //## Operation: setChainProposal%4623AC5A01C8
      void setChainProposal (const string& proposalName, const string& optInitArg = string(""));

      //## Operation: reportChainProposal%4623ACB002A4
      void reportChainProposal () const;

      //## Operation: checkCovarForSynch%4655D5AD00C7
      bool checkCovarForSynch () const;

      //## Operation: getParErrorRange%46A8E1CB020F
      std::pair<Real,Real> getParErrorRange (const Real confidence, const size_t parNum, const string& modName) const;

      //## Operation: appendToChain%46B38241014A
      void appendToChain (const string& chainName, const size_t addLength, const Real temperature, const string& format);

    //## Get and Set Operations for Class Attributes (generated)

      //## Attribute: length%4186574A0219
      size_t length () const;

      //## Attribute: width%4186577C02D6
      size_t width () const;

      //## Attribute: allLengthsSame%41A223EF0150
      bool allLengthsSame () const;

      //## Attribute: isSynchedWithFitParams%461A7FE202AE
      bool isSynchedWithFitParams () const;
      void isSynchedWithFitParams (bool value);

      //## Attribute: accumulatedLengths%461BFBF30396
      //	Internal bookkeeping array, primarily used to determine
      //	which file contains the nth point numbered from the
      //	start of the first chain file.
      const std::vector<size_t>& accumulatedLengths () const;

      //## Attribute: chainProposal%4623AAC0021F
      RandomizerBase* chainProposal ();

      //## Attribute: chainSVDevalue%4623BC6F016E
      const RealArray& chainSVDevalue () const;

      //## Attribute: chainSVDevector%4623BCBD0282
      const RealArray& chainSVDevector () const;

      //## Attribute: chainCovariance%4665822802CF
      const RealArray& chainCovariance () const;

      //## Attribute: lastStatCalc%473C595403AA
      const ChainManager::Stats& lastStatCalc () const;

    //## Get and Set Operations for Associations (generated)

      //## Association: XSFit::Fit::<unnamed>%418653FA00D8
      //## Role: ChainManager::chains%418653FB0318
      //## Qualifier: fileName%418654A30270; const string&
      const ChainManager::ChainContainer& chains () const;
      const Chain* getChain (const string& fileName) const;

      //## Association: XSFit::MCMC::<unnamed>%41FA791402B7
      //## Role: ChainManager::marginGrid%41FA791503C0
      MarginGrid* marginGrid () const;
      void marginGrid (MarginGrid* value);

  public:
    // Additional Public Declarations
      //## begin ChainManager%41864F1C034A.public preserve=yes
      
      // Functors which can be passed to forEachChainPoint.
      
      class CollectParVals
      {
         public:
            CollectParVals(size_t iPar) : m_iPar(iPar) {} 
            void operator () (const std::vector<Real>& chainPoint)
            {
               // For speed, no checking performed here.
               m_parVals.push_back(chainPoint[m_iPar]);
            }
            std::vector<Real>& parVals() {return m_parVals;}
         private:
            const size_t m_iPar;
            std::vector<Real> m_parVals;
      };
      
      class CollectSumVar
      {
         public:
            CollectSumVar(size_t nPar);
            void operator () (const std::vector<Real>& chainPoint)
            {
               for (size_t j=0; j<m_nPar; ++j)
               {
                  Real chainVals_j = chainPoint[j];
                  m_chainSum[j] += chainVals_j;
                  const size_t jOffset = j*m_nPar;
                  for (size_t k=0; k<m_nPar; ++k)
                  {
                     m_chainVariance[jOffset+k] += chainPoint[k]*chainVals_j;
                  }
               }
            }
            double* getChainSum() {return m_chainSum;}
            double* getChainVariance() {return m_chainVariance;}
         private:
            const size_t m_nPar;
            XSutility::auto_array_ptr<double> m_apChainSum;
            XSutility::auto_array_ptr<double> m_apChainVariance;
            double* m_chainSum;
            double* m_chainVariance;
      };
      //## end ChainManager%41864F1C034A.public
  protected:
    //## Constructors (generated)
      ChainManager();

    // Additional Protected Declarations
      //## begin ChainManager%41864F1C034A.protected preserve=yes
      //## end ChainManager%41864F1C034A.protected

  private:
    //## Constructors (generated)
      ChainManager(const ChainManager &right);

    //## Assignment Operation (generated)
      ChainManager & operator=(const ChainManager &right);


    //## Other Operations (specified)
      //## Operation: getChainForRandomPoint%461BE85603DC
      const Chain* getChainForRandomPoint (size_t globalLocation, size_t& locInChain) const;

      //## Operation: findParPosition%46B0C77902C7
      size_t findParPosition (const size_t parNum, const string& modName) const;

    // Additional Private Declarations
      //## begin ChainManager%41864F1C034A.private preserve=yes
      template <class Op>
      void forEachChainPoint(Op& oper) const;
      //## end ChainManager%41864F1C034A.private
  private: //## implementation
    // Data Members for Class Attributes

      //## Attribute: instance%4186526402A8
      //## begin ChainManager::instance%4186526402A8.attr preserve=no  private: static ChainManager* {U} 0
      static ChainManager* s_instance;
      //## end ChainManager::instance%4186526402A8.attr

      //## begin ChainManager::length%4186574A0219.attr preserve=no  public: size_t {U} 
      size_t m_length;
      //## end ChainManager::length%4186574A0219.attr

      //## begin ChainManager::width%4186577C02D6.attr preserve=no  public: size_t {U} 
      size_t m_width;
      //## end ChainManager::width%4186577C02D6.attr

      //## begin ChainManager::allLengthsSame%41A223EF0150.attr preserve=no  public: bool {U} 
      bool m_allLengthsSame;
      //## end ChainManager::allLengthsSame%41A223EF0150.attr

      //## begin ChainManager::isSynchedWithFitParams%461A7FE202AE.attr preserve=no  public: bool {U} 
      bool m_isSynchedWithFitParams;
      //## end ChainManager::isSynchedWithFitParams%461A7FE202AE.attr

      //## begin ChainManager::accumulatedLengths%461BFBF30396.attr preserve=no  public: std::vector<size_t> {U} 
      std::vector<size_t> m_accumulatedLengths;
      //## end ChainManager::accumulatedLengths%461BFBF30396.attr

      //## begin ChainManager::chainProposal%4623AAC0021F.attr preserve=no  public: RandomizerBase* {U} 
      RandomizerBase* m_chainProposal;
      //## end ChainManager::chainProposal%4623AAC0021F.attr

      //## begin ChainManager::chainSVDevalue%4623BC6F016E.attr preserve=no  public: RealArray {U} 
      RealArray m_chainSVDevalue;
      //## end ChainManager::chainSVDevalue%4623BC6F016E.attr

      //## begin ChainManager::chainSVDevector%4623BCBD0282.attr preserve=no  public: RealArray {U} 
      RealArray m_chainSVDevector;
      //## end ChainManager::chainSVDevector%4623BCBD0282.attr

      //## begin ChainManager::chainCovariance%4665822802CF.attr preserve=no  public: RealArray {U} 
      RealArray m_chainCovariance;
      //## end ChainManager::chainCovariance%4665822802CF.attr

      //## begin ChainManager::lastStatCalc%473C595403AA.attr preserve=no  public: ChainManager::Stats {U} 
      ChainManager::Stats m_lastStatCalc;
      //## end ChainManager::lastStatCalc%473C595403AA.attr

    // Data Members for Associations

      //## Association: XSFit::Fit::<unnamed>%418653FA00D8
      //## begin ChainManager::chains%418653FB0318.role preserve=no  public: Chain { -> 1..nVHgN}
      ChainManager::ChainContainer m_chains;
      //## end ChainManager::chains%418653FB0318.role

      //## Association: XSFit::MCMC::<unnamed>%41FA791402B7
      //## begin ChainManager::marginGrid%41FA791503C0.role preserve=no  public: MarginGrid {1 -> 1RFHN}
      MarginGrid* m_marginGrid;
      //## end ChainManager::marginGrid%41FA791503C0.role

      //## Association: XSFit::MCMC::<unnamed>%4655CBA50089
      //## Role: ChainManager::covarParams%4655CBA601C6
      //## begin ChainManager::covarParams%4655CBA601C6.role preserve=no  public: Chain::ParamID { -> 1..nVHgN}
      std::vector<Chain::ParamID> m_covarParams;
      //## end ChainManager::covarParams%4655CBA601C6.role

    // Additional Implementation Declarations
      //## begin ChainManager%41864F1C034A.implementation preserve=yes
      //## end ChainManager%41864F1C034A.implementation

};

//## begin ChainManager%41864F1C034A.postscript preserve=yes
std::ostream& operator<< (std::ostream& os, const ChainManager::Stats& right);


template <class Op>
void ChainManager::forEachChainPoint(Op& oper) const
{
   ChainContainer::const_iterator itChain = m_chains.begin();
   ChainContainer::const_iterator itEnd = m_chains.end();
   while (itChain != itEnd)
   {
      Chain* chain = itChain->second;
      const int len = chain->length();
      chain->openForReadPoints();
      for (int i=0; i<len; ++i)
      {
         std::vector<Real> chainVals;
         chain->readPoint(chainVals);
         oper(chainVals);
      }
      chain->closeFile();
      ++itChain;
   }
}
//## end ChainManager%41864F1C034A.postscript

// Class ChainManager::Stats 

// Class ChainManager 

//## Get and Set Operations for Class Attributes (inline)

inline size_t ChainManager::length () const
{
  //## begin ChainManager::length%4186574A0219.get preserve=no
  return m_length;
  //## end ChainManager::length%4186574A0219.get
}

inline size_t ChainManager::width () const
{
  //## begin ChainManager::width%4186577C02D6.get preserve=no
  return m_width;
  //## end ChainManager::width%4186577C02D6.get
}

inline bool ChainManager::allLengthsSame () const
{
  //## begin ChainManager::allLengthsSame%41A223EF0150.get preserve=no
  return m_allLengthsSame;
  //## end ChainManager::allLengthsSame%41A223EF0150.get
}

inline bool ChainManager::isSynchedWithFitParams () const
{
  //## begin ChainManager::isSynchedWithFitParams%461A7FE202AE.get preserve=no
  return m_isSynchedWithFitParams;
  //## end ChainManager::isSynchedWithFitParams%461A7FE202AE.get
}

inline void ChainManager::isSynchedWithFitParams (bool value)
{
  //## begin ChainManager::isSynchedWithFitParams%461A7FE202AE.set preserve=no
  m_isSynchedWithFitParams = value;
  //## end ChainManager::isSynchedWithFitParams%461A7FE202AE.set
}

inline const std::vector<size_t>& ChainManager::accumulatedLengths () const
{
  //## begin ChainManager::accumulatedLengths%461BFBF30396.get preserve=no
  return m_accumulatedLengths;
  //## end ChainManager::accumulatedLengths%461BFBF30396.get
}

inline RandomizerBase* ChainManager::chainProposal ()
{
  //## begin ChainManager::chainProposal%4623AAC0021F.get preserve=no
  return m_chainProposal;
  //## end ChainManager::chainProposal%4623AAC0021F.get
}

inline const RealArray& ChainManager::chainSVDevalue () const
{
  //## begin ChainManager::chainSVDevalue%4623BC6F016E.get preserve=no
  return m_chainSVDevalue;
  //## end ChainManager::chainSVDevalue%4623BC6F016E.get
}

inline const RealArray& ChainManager::chainSVDevector () const
{
  //## begin ChainManager::chainSVDevector%4623BCBD0282.get preserve=no
  return m_chainSVDevector;
  //## end ChainManager::chainSVDevector%4623BCBD0282.get
}

inline const RealArray& ChainManager::chainCovariance () const
{
  //## begin ChainManager::chainCovariance%4665822802CF.get preserve=no
  return m_chainCovariance;
  //## end ChainManager::chainCovariance%4665822802CF.get
}

inline const ChainManager::Stats& ChainManager::lastStatCalc () const
{
  //## begin ChainManager::lastStatCalc%473C595403AA.get preserve=no
  return m_lastStatCalc;
  //## end ChainManager::lastStatCalc%473C595403AA.get
}

//## Get and Set Operations for Associations (inline)

inline const ChainManager::ChainContainer& ChainManager::chains () const
{
  //## begin ChainManager::chains%418653FB0318.get preserve=no
  return m_chains;
  //## end ChainManager::chains%418653FB0318.get
}

inline const Chain* ChainManager::getChain (const string& fileName) const
{
  //## begin ChainManager::getChain%418653FB0318.qualget preserve=yes
  ChainContainer::const_iterator it = m_chains.find(fileName);
  const Chain* chain = (it != m_chains.end()) ? it->second : 0;
  return chain;
  //## end ChainManager::getChain%418653FB0318.qualget
}

inline MarginGrid* ChainManager::marginGrid () const
{
  //## begin ChainManager::marginGrid%41FA791503C0.get preserve=no
  return m_marginGrid;
  //## end ChainManager::marginGrid%41FA791503C0.get
}

inline void ChainManager::marginGrid (MarginGrid* value)
{
  //## begin ChainManager::marginGrid%41FA791503C0.set preserve=no
  m_marginGrid = value;
  //## end ChainManager::marginGrid%41FA791503C0.set
}

//## begin module%41864D9F0301.epilog preserve=yes
//## end module%41864D9F0301.epilog


#endif
